Subject: Re: [tsvwg] I-D Action: draft-ietf-tsvwg-udp-options-09.txt - ROHC

From: Gorry Fairhurst <[email-masked]>
Date: Wed, 10 Feb 2021 12:31:52 +0000

Carsten,

I'd like to see if we can find suitable text for the discussion of ROHC 
within the UDP-Options draft.

My own understanding is also that ROHC-compressed UDP packets need to 
match the profile for UDP defined in RFC3095, and that use of 
UDP-Options would result in a packet that can't compressed by the 
current profile - and hence would be sent uncompressed. If I understand 
correctly, this seems worth recording. However the current ID text goes 
further than this, and proposes an update.

Would you like to propose some alternate text for the WG to discuss?

Gorry

On 18/12/2020 14:17, Carsten Bormann wrote:
> On 2020-11-26, at 01:14, Joseph Touch <[email-masked]> wrote:
>> 	• This doc now updates ROHC 3095 too
>> 		• puts it in line with more recent header compression standards that we caught
>> 		• UDP header compression should ever have assumed that UDP Length is implicit based on IP length
> Specifically, the draft now says:
>
>     This document hereby deprecates the requirement asserted in the UDP
>     profile for Robust Header Compression (ROHC)[RFC3095], noted here:
>
>        "The Length field of the UDP header MUST match the Length
>         field(s) of the preceding subheaders, i.e., there must not
>         be any padding after the UDP payload that is covered by the
>         IP Length.”
>
> This change is highly confused.
>
> You indeed cannot initialize an IR header chain from from a UDP packet where this does not match.  So you would send that uncompressed.  If this MUST were changed, the receiver no longer would be able what length to put into decompressed UDP packets.
>
> Somehow, I feel like responding to an errata report that needs to be rejected…
>
> Grüße, Carsten

---

From: Joseph Touch <[email-masked]>
Date: Wed, 10 Feb 2021 07:50:51 -0800

Hi, Gorry,

I think the discussion we had back in Dec concluded that “you can only USE a profile if it applies”, so that would mean a correct ROHC implementation would need to *check* whether the UDP Length was consistent with the IP length and only compress using the given profile if that were true.

So the UDP options doc does not need to update ROHC, but I think we do need to make this clear in our doc.

Joe

> On Feb 10, 2021, at 4:31 AM, Gorry Fairhurst <[email-masked]> wrote:
> 
> Carsten,
> 
> I'd like to see if we can find suitable text for the discussion of ROHC within the UDP-Options draft.
> 
> My own understanding is also that ROHC-compressed UDP packets need to match the profile for UDP defined in RFC3095, and that use of UDP-Options would result in a packet that can't compressed by the current profile - and hence would be sent uncompressed. If I understand correctly, this seems worth recording. However the current ID text goes further than this, and proposes an update.
>

---

From: Carsten Bormann <[email-masked]>
Date: Wed, 10 Feb 2021 17:13:23 +0100

Note that with ROHCv2, the Protocol is STATIC-DEF, so you should be able to set up an instance of the UDP-Lite profiles (0x107 and 0x108) in the presence of UDP-Options.  I think.

Grüße, Carsten

> On 2021-02-10, at 16:50, Joseph Touch <[email-masked]> wrote:
> 
> Hi, Gorry,
>

---

From: Carsten Bormann <[email-masked]>
Date: Wed, 10 Feb 2021 17:24:53 +0100

On 2021-02-10, at 17:13, Carsten Bormann <[email-masked]> wrote:
> ROHCv2

Even with ROHCv1, Protocol/Next Header is part of the static chain, so RFC 4019 (profiles 0x0007/0x0008) should apply to UDP-with-options.  I just can’t remember what the opaque comments pointing to RFC 3095 Section 5.7.7.8 mean (this was before we had a formal notation)…

Something for the ROHC mailing list, I think.

Grüße, Carsten